%define gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%define gemname mongrel_cluster
%define geminstdir %{gemdir}/gems/%{gemname}-%{version}
%define ruby_sitelib %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%define ruby_abiver %((echo "1.8"; ruby -rrbconfig -e "puts Config::CONFIG['ruby_version']" 2>/dev/null) | tail -1)

Summary:           GemPlugin wrapper for the mongrel HTTP server
Name:              rubygem-%{gemname}
Version:           1.0.5
Release:           4%{?dist}
License:           GPLv2 or Ruby
Group:             System Environment/Daemons
URL:               http://mongrel.rubyforge.org/wiki/MongrelCluster
Source0:           http://gems.rubyforge.org/gems/%{gemname}-%{version}.gem
Source1:           mongrel_cluster.init
Requires:          ruby(abi) = %{ruby_abiver}, rubygems, rubygem(mongrel) >= 1.0.0
Requires(post):    /sbin/chkconfig
Requires(preun):   /sbin/service, /sbin/chkconfig
Requires(postun):  /sbin/service
Provides:          rubygem(%{gemname}) = %{version}
BuildRequires:     rubygems
BuildArch:         noarch
BuildRoot:         %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Mongrel_cluster is a GemPlugin that wrappers the mongrel HTTP server and
simplifies the deployment of webapps using a cluster of mongrel servers.
Mongrel_cluster will conveniently configure and control several mongrel
servers or groups of mongrel servers, which are then load balanced using
a reverse proxy solution. 

%prep

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{gemdir}
gem install --local --install-dir $RPM_BUILD_ROOT%{gemdir} --force --rdoc %{SOURCE0}

find $RPM_BUILD_ROOT -type f | xargs -n 1 sed -i -e 's@^#!/usr/bin/env ruby@#!/usr/bin/ruby@'
rm -f $RPM_BUILD_ROOT%{geminstdir}/{Manifest,mongrel_cluster.gemspec}
rm -f $RPM_BUILD_ROOT%{gemdir}/bin/mongrel_cluster_ctl
rm -f $RPM_BUILD_ROOT%{geminstdir}/resources/%{gemname}

# Copy the initscript to its appropriate place
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/{rc.d/init.d,%{gemname}}
install -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/%{gemname}

# Move the mongrel_cluster_ctl to correct place
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mv -f $RPM_BUILD_ROOT%{geminstdir}/bin/mongrel_cluster_ctl $RPM_BUILD_ROOT%{_bindir}

%post
/sbin/chkconfig --add %{gemname}

%preun
if [ $1 -eq 0 ]; then
  /sbin/service %{gemname} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{gemname}
fi

%postun
if [ $1 -ne 0 ]; then
  /sbin/service %{gemname} condrestart > /dev/null 2>&1 || :
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc %{geminstdir}/CHANGELOG
%doc %{geminstdir}/COPYING
%doc %{geminstdir}/LICENSE
%doc %{geminstdir}/README
%{_bindir}/mongrel_cluster_ctl
%{_sysconfdir}/rc.d/init.d/%{gemname}
%dir %{_sysconfdir}/%{gemname}
%dir %{geminstdir}
%{geminstdir}/lib
%{geminstdir}/resources
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%changelog
* Sun Aug 02 2009 Robert Scheck <robert@fedoraproject.org> 1.0.5-4
- Corrected a typo for output redirection in the initscript
- Removed the conditionalizing of ruby(abi) = version for EPEL

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue May 26 2009 Robert Scheck <robert@fedoraproject.org> 1.0.5-2
- Added missing requirement to ruby(abi) = version (#501134 #c1)
- Rewrote initscript to support single clusters and reload/subsys

* Sat May 16 2009 Robert Scheck <robert@fedoraproject.org> 1.0.5-1
- Upgrade to 1.0.5

* Mon Jul 21 2008 Robert Scheck <robert@fedoraproject.org> 1.0.4-1
- Upgrade to 1.0.4
- Initial spec file for Fedora and Red Hat Enterprise Linux
